<?php
namespace TecFood\Services;

use Doctrine\DBAL\Connection;
use Teknisa\Libs\Util\Environment;

class MarcaService
{
    protected $dataSourceName = "marca";
    protected $crudService;
    
    public function __construct($crudService, Connection $connection, Environment $environment)
    {
        $this->crudService = $crudService;
        $this->connection = $connection;
        $this->environment = $environment;
    }
    
    public function verifyMarcaExists($row)
    {
        $query = "SELECT CDMARCA FROM MARCA WHERE CDMARCA = :P_CDMARCA AND NRORG = :P_NRORG";
        $params = array(
            'P_CDMARCA' => $row['CDMARCA'],
            'P_NRORG'   => $this->environment->getNrorg(),
        );

        $stmt = $this->connection->prepare($query);
        $stmt->execute($params);
        
        return $stmt->fetch();
    }
    
    public function saveImport($rows)
    {
        $this->crudService->save($this->dataSourceName, $rows);
    }
}
